<?php
# ***** BEGIN LICENSE BLOCK *****
# Privacy plugin for Dotclear
# Copyright (c) 2006 Jean-Marie Favreau
# Copyright (c) 2004-2005 Lol Zimmerli. All rights reserved.
#
# This is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# It is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# ***** END LICENSE BLOCK *****

# Variables
$url = 'tools.php?p=personnel';
$accessFilename = realpath(dirname(__FILE__).'/../../../').'/.htaccess';
$passwdFilename = realpath(dirname(__FILE__).'/../../../').'/.htpasswd';
$host = explode(".", $_SERVER["HTTP_HOST"]);
$path = explode("/", $_SERVER["PHP_SELF"]);
$realm = ($host[0] == "www") ? $host[1] : $host[0];
$realm .= " ".$path[1];
$passwdFilenameRelative = str_replace($_SERVER['DOCUMENT_ROOT'],'',$passwdFilename);

# Switch
$edited = (!empty($_POST['edited'])) ? $_POST['edited'] : '';

buffer::str('<h2>'.__("Personal blog").'</h2>');


if ($edited == 1){

  if (isset($_POST["submit"])){ // Save auth

# Check values
    if (($_POST["username"] == "") or ($_POST["password"] == "") or ($_POST["password2"] == "")){
      buffer::str(__('Error: please fill the three fields.'));
    }
    elseif ($_POST["password"] != $_POST["password2"]){
      buffer::str(__('"Password" and "Confirm password" mismatch.'));
    }
    else{
      $user = $_POST["username"];
      $pass = $_POST["password"];
      $passwdFileContents = "$user:$pass";

      $accessFileContents = <<<EOS
      PerlSetVar AuthFile $passwdFilenameRelative
      AuthName "$realm"
      AuthType Basic
      require valid-user AuthType Basic
EOS;
      
      $handle = fopen($accessFilename, 'w');
      $ok = fwrite($handle, $accessFileContents);
      fclose($handle);
      
      if ($ok){
	$handle = fopen($passwdFilename, 'w');
	$ok = fwrite($handle, $passwdFileContents);
	fclose($handle);

	copy(dirname(__FILE__)."/close.png", dirname(__FILE__)."/icon.png");

	buffer::str('<h3>'.__('Ok, authorization installed.').'</h3>');
      }
      else{
	buffer::str('<h3>'.__('Cannot write files, error!').'</h3>');
      }
    } 
  }
  elseif(isset($_POST["submit2"])){ // Del auth
    $ok = unlink($accessFilename);
    if ($ok){
      unlink($passwdFilename);
      copy(dirname(__FILE__)."/open.png", dirname(__FILE__)."/icon.png");
      buffer::str('<h3>'.__('Ok, authorization deleted').'</h3>');
    }
    else{
      buffer::str('<h3>'.__('Cannot delete authorization, error!').'</h3>');
    }
  }
  else{
    buffer::str('<h3>'.__('Fatal Error, no action.').'</h3>');
  }

}
else{

  if (file_exists($passwdFilename)){
    $handle = fopen($passwdFilename, 'r');
    $contents = fread($handle, filesize($passwdFilename));
    fclose($handle);
    $contArr = explode(":", $contents);
    $lastUsername = $contArr[0];
  }
  else $lastUsername = "";
  buffer::str(
	      '<fieldset class="clear"><legend>'.__('Authorization').'</legend>'.
	      '<form action="'.$url.'" method="post"><input type="hidden" name="edited" value="1" />'.

	      '<p>'.__('Warning: you will be prompted to identify yourself as a user of your private blog soon after you save the authorization').'.</p>'.

	      '<p><label for="title"><strong>'.__('Username').': </strong></label>'.
	      '<input type="text" name="username" value="'.$lastUsername.'" /></p>'.
	      '<p><label for="title"><strong>'.__('Password').': </strong></label>'.
              '<input type="text" name="password" /></p>'.
	      '<p><label for="title"><strong>'.__('Confirm password').': </strong></label>'.
              '<input type="text" name="password2" /></p>'.

	      '<p><input type="submit" name="submit" class="submit" value="'.__('Save authorization').'" /></p>'.

	      '<p><strong>'.__('Please note that this pluggin will ask a user password also when reaching the website administration.').'</strong></p>'.

	      '<p><label for="submit2"><br />'.__('If you want the blog to be seen by anyone, without password').':</label>'.
              '<input type="submit" name="submit2" class="submit" value="'.__('Delete authorization').'" /></form></p>'

	);
}

?>
